/**
	$Id: ButtonBean.java 6096 2012-09-03 07:06:01Z nicklas $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.toolbar;

/**
	A simple bean-like implementation of the {@link ButtonAction}
	interface.
	
	@author nicklas
	@version 2.7
	@base.modified $Date: 2012-09-03 09:06:01 +0200 (Mon, 03 Sep 2012) $
*/
public class ButtonBean 
	implements ButtonAction 
{

	private String clazz;
	private String icon;
	private String id;
	private String onClick;
	private String style;
	private String title;
	private String tooltip;
	private boolean enabled;
	private boolean visible;
	private int tabIndex;

	
	public ButtonBean()
	{}
	
	/*
		From the ToolbarButtonAction interface
		--------------------------------
	*/
	@Override
	public String getClazz() 
	{
		return clazz;
	}

	@Override
	public String getIcon() 
	{
		return icon;
	}

	@Override
	public String getId() 
	{
		return id;
	}

	@Override
	public String getOnClick() 
	{
		return onClick;
	}

	@Override
	public String getStyle() 
	{
		return style;
	}

	@Override
	public String getTitle() 
	{
		return title;
	}

	@Override
	public String getTooltip() 
	{
		return tooltip;
	}

	@Override
	public boolean isEnabled() 
	{
		return enabled;
	}

	@Override
	public boolean isVisible() 
	{
		return visible;
	}
	
	@Override
	public int getTabIndex()
	{
		return tabIndex;
	}
	// ---------------------------

	public void setClazz(String clazz) 
	{
		this.clazz = clazz;
	}

	public void setIcon(String icon) 
	{
		this.icon = icon;
	}

	public void setId(String id) 
	{
		this.id = id;
	}

	public void setOnClick(String onClick) 
	{
		this.onClick = onClick;
	}

	public void setStyle(String style) 
	{
		this.style = style;
	}

	public void setTitle(String title) 
	{
		this.title = title;
	}

	public void setTooltip(String tooltip) 
	{
		this.tooltip = tooltip;
	}

	public void setEnabled(boolean enabled) 
	{
		this.enabled = enabled;
	}

	public void setVisible(boolean visible) 
	{
		this.visible = visible;
	}
	
	public void setTabIndex(int tabIndex)
	{
		this.tabIndex = tabIndex;
	}
	
}
