/**
	$Id: ComparableComparator.java 5570 2011-02-16 13:49:40Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util;

import java.util.Comparator;

/**

	A comparator implemenation for any Comparable objects.

	@author Nicklas
	@since 2.17
	@base.modified $Date: 2011-02-16 14:49:40 +0100 (Wed, 16 Feb 2011) $
*/
public class ComparableComparator<T extends Comparable<T>>
	implements Comparator<T>
{

	public ComparableComparator()
	{}
	
	/*
		From the Comparator interface
		-----------------------------
	*/
	@Override
	public int compare(T o1, T o2)
	{
		return o1.compareTo(o2);
	}
	// -----------------------------
}
