/**
	$Id: ToStringFormatter.java 4544 2008-09-25 07:01:30Z nicklas $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.formatter;


/**
 	A generic formatter that simply formats objects by calling the
 	toString() method. Null values are converted to the empty string.
 	
	@author nicklas
	@version 2.0
	@base.modified $Date: 2008-09-25 09:01:30 +0200 (Thu, 25 Sep 2008) $
*/
public class ToStringFormatter<T>
	implements Formatter<T>
{

	/**
		Create a new integer formatter.
	*/
	public ToStringFormatter()
	{}
	
	/*
		From the Formatter interface
		-------------------------------------------
	*/
	public String format(T value)
	{
		return value == null ? "" : value.toString();
	}
	public T parseString(String value)
	{
		throw new UnsupportedOperationException("parseString");
	}
	// -------------------------------------------

}
