/**
	$Id $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
 	This holds information about a file set member in BASE.
 	It can be used to send information about this kind of item
 	over web services.
 	@see net.sf.basedb.core.FileSetMember
  	@author Nicklas
  	@since 3.0
 	
 */
public class FileSetMemberInfo 
	extends BasicItemInfo
	implements Serializable
{
	
	private static final long serialVersionUID = -1598316469318145859L;
	private DataFileTypeInfo fileType;
	private FileInfo file;
	private Boolean isValid;
	private String errorMessage;
	/**
	 	
	 */
	public FileSetMemberInfo()
	{
		super();
	}

	public void setDataFileTypeInfo(DataFileTypeInfo fileType)
	{
		this.fileType = fileType;
	}

	public DataFileTypeInfo getDataFileTypeInfo()
	{
		return fileType;
	}
	
	public void setFileInfo(FileInfo file)
	{
		this.file = file;
	}

	public FileInfo getFileInfo()
	{
		return file;
	}

	public void setValid(Boolean isValid)
	{
		this.isValid = isValid;
	}
	
	public Boolean getValid()
	{
		return isValid;
	}
	
	public void setErrorMessage(String msg)
	{
		this.errorMessage = msg;
	}
	
	public String getErrorMessage()
	{
		return errorMessage;
	}
}