/**
	$Id: RawBioAssayInfo.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
  	An information class that holds information about an 
 	{@link net.sf.basedb.core.RawBioAssay} in BASE.
 	This class only holds simple objects that can
 	be handled by web services.
  	@author Martin, Nicklas
  	@version 2.5 	
*/
public class RawBioAssayInfo 
	extends AnnotatedItemInfo 
		implements Serializable
{

	private static final long serialVersionUID = 2573863131262198133L;
	private int arrayDesignId = 0;
	private int platformId = 0;
	private String rawDataTypeId = null;
	
	/**
	 	Creates information object with 
	 	no properties set.
	 */
	public RawBioAssayInfo()
	{
		super();
	}

	/**	
	  	@param arrayDesignId The arrayDesignId to set.
	*/
	public void setArrayDesignId(int arrayDesignId)
	{
		this.arrayDesignId = arrayDesignId;
	}

	/**	
	 	@return Returns the arrayDesignId.
	*/
	public int getArrayDesignId()
	{
		return arrayDesignId;
	}

	/**	
	  	@param platformId The platformId to set.
	*/
	public void setPlatformId(int platformId)
	{
		this.platformId = platformId;
	}

	/**	
	 	@return Returns the platformId.
	*/
	public int getPlatformId()
	{
		return platformId;
	}

	/**	
	  	@param rawDataTypeId The rawDataTypeId to set.
	*/
	public void setRawDataTypeId(String rawDataTypeId)
	{
		this.rawDataTypeId = rawDataTypeId;
	}

	/**	
	 	@return Returns the rawDataTypeId.
	*/
	public String getRawDataTypeId()
	{
		return rawDataTypeId;
	}
}
