import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/*
 $Id$

 Copyright (C) 2006 Johan Enell

 This file is part of BASE - BioArray Software Environment.
 Available at http://base.thep.lu.se/

 BASE is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 BASE is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with BASE. If not, see <http://www.gnu.org/licenses/>.
 */

public class Base1NullPlugin
{

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException
	{
		PrintWriter log = new PrintWriter("base1nullplugin.log");
		log.println("base1nullplugin started");
		
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String line = in.readLine();
		while (line != null)
		{
			if (line.startsWith("assayFields") && line.contains("_xc_"))
			{
				/*
					The file contains extra values. To make the
					import work we must remove the _xc_ prefix for the
					extra value columns and add a setExtraFloats header
				*/
				String[] columns = line.split("\\t");
				line = "assayFields";
				String setExtraFloats = "setExtraFloats";
				for (int i = 1; i < columns.length; ++i)
				{
					String column = columns[i];
					if (column.startsWith("_xc_"))
					{
						column = column.substring(4);
						setExtraFloats += "\t" + column;
					}
					line += "\t" + column;
				}
				System.out.println(setExtraFloats);
			}
			System.out.println(line);
			log.println(line);
			line = in.readLine();
			log.flush();
		}
		
		log.println("base1nullplugin ended");
		log.close();
	}

}
