<%-- $Id: index.jsp 6045 2012-04-03 12:23:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Collection"
	import="java.util.Arrays"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,valueType,requiredForMiame,itemTypes,description");
	private static final Item itemType = Item.ANNOTATIONTYPE;
	
	private static void registerExportUtils(ItemContext cc)
	{
		// Register formatter
		cc.setObject("export.formatter.&categories(name)", new NameableFormatter());
		
		// Register dataloader
		String typeParameter = "annotationType";
		ItemQuery<AnnotationTypeCategory> categoryQuery = AnnotationTypeCategory.getQuery();
		categoryQuery.include(cc.getInclude());
		categoryQuery.join(Hql.innerJoin("annotationTypes", "atp"));
		categoryQuery.restrict(Restrictions.eq(Hql.alias("atp"), Expressions.parameter(typeParameter)));
		categoryQuery.order(Orders.asc(Hql.property("name")));
		cc.setObject("export.dataloader.&categories(name)", new ItemQueryLoader(categoryQuery, typeParameter));
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_annotationtypes.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_annotationtype.jsp?ID="+ID;
final String editPage = "edit_annotationtype.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		redirect = editPage+"&value_type="+request.getParameter("value_type");
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl();
		AnnotationType annotationType = (AnnotationType)cc.getObject("item");
		if (annotationType == null)
		{
			Type valueType = Type.valueOf(request.getParameter("value_type"));
			annotationType = AnnotationType.getNew(dc, valueType);
			message = "Annotation type created";
			dc.saveItem(annotationType);
		}
		else
		{
			dc.reattachItem(annotationType, false);
			message = "Annotation type updated";
		}
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.ANNOTATIONTYPE), annotationType);
		ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			annotationType.setName(Values.getStringOrNull(request.getParameter("name")));
			annotationType.setDescription(Values.getStringOrNull(request.getParameter("description")));
			annotationType.setExternalId(Values.getStringOrNull(request.getParameter("external_id")));
			annotationType.setMultiplicity(Values.getInt(request.getParameter("multiplicity"), 0));
			annotationType.setDefaultValue(request.getParameter("defaultValue"));
			annotationType.setRequiredForMiame(Values.getBoolean(request.getParameter("required_for_miame")));
			annotationType.setProtocolParameter(Values.getBoolean(request.getParameter("is_protocol_parameter")));
			if (annotationType.getValueType().canEnumerate())
			{
				annotationType.setEnumeration(!"box".equals(request.getParameter("interface")));
			}
			
			// Options tab
			Type valueType = annotationType.getValueType();
			if (valueType == Type.INT || valueType == Type.LONG)
			{
				annotationType.setMinValueLong(Values.getLong(request.getParameter("minValue"), null));
				annotationType.setMaxValueLong(Values.getLong(request.getParameter("maxValue"), null));
				annotationType.setWidth(Values.getInt(request.getParameter("width"), 40));
				if (annotationType.isEnumeration())
				{
					Object[] values = null;
					if (valueType == Type.INT)
					{
						values = Values.getInt(request.getParameter("values").split("[\n\r]+"));
					}
					else
					{
						values = Values.getLong(request.getParameter("values").split("[\n\r]+"));
					}
					annotationType.setValues(Arrays.asList(values));
					annotationType.setDisplayAsList("list".equals(request.getParameter("interface")));
				}
			}
			else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
			{
				annotationType.setMinValueDouble(Values.getDouble(request.getParameter("minValue"), null));
				annotationType.setMaxValueDouble(Values.getDouble(request.getParameter("maxValue"), null));
				annotationType.setWidth(Values.getInt(request.getParameter("width"), 40));
				if (annotationType.isEnumeration())
				{
					Object[] values = null;
					if (valueType == Type.FLOAT)
					{
						values = Values.getFloat(request.getParameter("values").split("[\n\r]+"));
					}
					else
					{
						values = Values.getDouble(request.getParameter("values").split("[\n\r]+"));
					}
					annotationType.setValues(Arrays.asList(values));
					annotationType.setDisplayAsList("list".equals(request.getParameter("interface")));
				}
			}
			else if (valueType == Type.STRING)
			{
				annotationType.setMaxLength(Values.getInteger(request.getParameter("maxLength"), null));
				annotationType.setWidth(Values.getInt(request.getParameter("width"), 40));
				if (annotationType.isEnumeration())
				{
					String[] values = request.getParameter("values").split("[\n\r]+");
					annotationType.setValues(Arrays.asList(values));
					annotationType.setDisplayAsList("list".equals(request.getParameter("interface")));
				}
			}
			else if (valueType == Type.TEXT)
			{
				annotationType.setWidth(Values.getInt(request.getParameter("width"), 40));
				annotationType.setHeight(Values.getInt(request.getParameter("height"), 10));
			}
			else if (valueType == Type.DATE)
			{
				annotationType.setWidth(Values.getInt(request.getParameter("width"), 40));
				if (annotationType.isEnumeration())
				{
					Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
					Date[] values = Values.getDate(request.getParameter("values").split("[\n\r]+"), dateFormatter);
					annotationType.setValues(Arrays.asList(values));
					annotationType.setDisplayAsList("list".equals(request.getParameter("interface")));
				}
			}
			
			// Item types tab
			Set<Item> allItems = Metadata.getAnnotatableItems();
			String[] enabled = request.getParameterValues("enabled");
			Collection<String> enabledItems = enabled != null ? Arrays.asList(enabled) : new ArrayList<String>();
			for (Item item : allItems)
			{
				if (enabledItems.contains(item.name()))
				{
					annotationType.enableForItem(item);
				}
				else
				{
					annotationType.disableForItem(item);
				}
			}
			
			// Units tab
			if (valueType.isNumerical())
			{
				int unitId = Values.getInt(request.getParameter("unit_id"), -1);
				if (unitId >= 0) // < 0 = denied or unchanged
				{
					Unit unit = unitId == 0 ? null : Unit.getById(dc, unitId);
					annotationType.setDefaultUnit(unit);
				}
				
				String[] removeUnits = Values.getString(request.getParameter("removeUsableUnits")).split(",");
				for (int i = 0; i < removeUnits.length; ++i)
				{
					int uId = Values.getInt(removeUnits[i], -1);
					if (uId != -1) annotationType.removeUsableUnit(Unit.getById(dc, uId));
				}
				
				String[] addUnits = Values.getString(request.getParameter("addUsableUnits")).split(",");
				for (int i = 0; i < addUnits.length; ++i)
				{
					int uId = Values.getInt(addUnits[i], -1);
					if (uId != -1) annotationType.addUsableUnit(Unit.getById(dc, uId));
				}
			}
			
			// Categories tab
			String[] removeCategories = Values.getString(request.getParameter("removeCategories")).split(",");
			for (int i = 0; i < removeCategories.length; ++i)
			{
				int categoryId = Values.getInt(removeCategories[i], -1);
				if (categoryId != -1) annotationType.removeCategory(AnnotationTypeCategory.getById(dc, categoryId));
			}
			
			String[] addCategories = Values.getString(request.getParameter("addCategories")).split(",");
			for (int i = 0; i < addCategories.length; ++i)
			{
				int categoryId = Values.getInt(addCategories[i], -1);
				if (categoryId != -1) annotationType.addCategory(AnnotationTypeCategory.getById(dc, categoryId));
			}
			
			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<AnnotationType> query = AnnotationType.getQuery(null);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		registerExportUtils(cc);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+annotation+types";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+annotation+type";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<AnnotationType> query = AnnotationType.getQuery(null);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+annotation+types";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+annotation+typey";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<AnnotationType> query = AnnotationType.getQuery(null);
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

