<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.DiskUsage"
	import="net.sf.basedb.core.DiskUsageStatistics"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DISKUSAGE;
	private static final String subContext = "perGroup";
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST, subContext);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final boolean writePermission = sc.hasPermission(Permission.WRITE, Item.GROUP);
final String showStatistics = Values.getString(cc.getSetting("showStatistics"), 
	Application.hasSecondaryStorage() ? "full" : "quotaType");

final boolean hasLocation = "location".equals(showStatistics) || "full".equals(showStatistics);
final boolean hasQuotaType = "quotaType".equals(showStatistics) || "full".equals(showStatistics);

final DbControl dc = sc.newDbControl();
ItemResultIterator<Group> groups = null;
try
{
	DiskUsageStatistics du = (DiskUsageStatistics)sc.getSessionSetting("diskUsageStatistics");
	if (du == null)
	{
		du = DiskUsage.getStatistics(dc);
		sc.setSessionSetting("diskUsageStatistics", du);
	}
	du.setDbControl(dc);
	List<QuotaType> quotaTypes = du.getQuotaTypes();
	
	try
	{
		final ItemQuery<Group> query = Base.getConfiguredQuery(dc, cc, true, Group.getQuery(), mode);
		query.include(Include.ALL);
		query.restrict(
				Restrictions.neq(
					Hql.property("quota"), null));
		groups = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="Disk usage">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'groups';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', 'GROUP', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', 'GROUP', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function setShowStatistics()
		{
			document.forms[formId].submit();
		}
		function viewDiskUsageDetails(groupId)
		{
			location.href = 'details/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id='+groupId+'&item_type=GROUP';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'overview')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=Overview';
			}
			else if (tabId == 'users')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ListUsers';
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}		
		</script>
		<style>
		table.special
		{
			border-collapse: collapse;
		}
		table.special td, table.special th
		{
			text-align: right;
			border-right: 1px dotted #A0A0A0;
			padding: 1px 2px 1px 2px;
		}
		</style>
	</base:head>
	
	<base:body>
		<h1>Disk usage</h1>
		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content" 
			active="groups" switch="switchTab">
		<t:tab id="overview" title="Overview" />
		<t:tab id="users" title="Per user" />
		<t:tab id="groups" title="Per group">
		<tbl:table 
			id="groups" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="subcontext"
				value="<%=subContext%>"
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="diskUsage"
				title="Disk usage summary"
				show="always"
			/>
			<tbl:columndef 
				id="quota"
				property="quota.name"
				datatype="string"
				title="Quota"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					visible="<%=mode.hasToolbar()%>"
					subclass="bottomborder"
					>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=groups == null ? 0 : groups.getTotalCount()%>" 
					/>
					<b>Show summary</b>
					<input type="radio" name="showStatistics" value="total"
						<%="total".equals(showStatistics) ? "checked" : ""%>
						onclick="setShowStatistics()"><a
						href="javascript:document.forms[formId].showStatistics[0].click()">Total only</a>
					<input type="radio" name="showStatistics" value="location"
						<%="location".equals(showStatistics) ? "checked" : ""%>
						onclick="setShowStatistics()"><a
						href="javascript:document.forms[formId].showStatistics[1].click()">Per location</a>
					<input type="radio" name="showStatistics" value="quotaType"
						<%="quotaType".equals(showStatistics) ? "checked" : ""%>
						onclick="setShowStatistics()"><a
						href="javascript:document.forms[formId].showStatistics[2].click()">Per quota type</a>
					<input type="radio" name="showStatistics" value="full"
						<%="full".equals(showStatistics) ? "checked" : ""%>
						onclick="setShowStatistics()"><a
						href="javascript:document.forms[formId].showStatistics[3].click()">Full</a>
				</tbl:panel>
			</div>

			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								onclick="Forms.checkUncheck(document.forms[formId])" 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (groups != null)
					{						
						while (groups.hasNext())
						{
							Group item = groups.next();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="diskUsage" style="padding: 0px;">
									<%
									DiskUsageStatistics.Summary summary = du.getSummary(item);
									long total = summary.getTotal();
									if (total > 0 && (hasLocation || hasQuotaType))
									{
										%>
										<table class="special bottomborder">
										<%
										if (hasLocation)
										{
											%>
											<tr class="bottomborder">
												<%
												if (hasQuotaType)
												{
													%>
													<th></th>
													<%
												}
												%>
												<th>Total</th>
												<td>Primary</td>
												<td>Secondary</td>
												<td>Offline</td>
												<td>External</td>
											</tr>
											<%
										}
										%>	
										<tr class="bottomborder" style="background: #D8D8D8;">
											<%
											if (hasQuotaType)
											{
												%>
												<th>Total</th>
												<%
											}
											%>
											<td><%=Values.formatBytes(total)%></td>
											<%
											if (hasLocation)
											{
												%>
												<td><%=Values.formatBytes(summary.getTotal(Location.PRIMARY))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.SECONDARY))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.OFFLINE))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.EXTERNAL))%></td>
												<%
											}
											%>
										</tr>	
										<%
										if (hasQuotaType && total > 0)
										{
											for (QuotaType qt : quotaTypes)
											{
												%>
												<tr>
													<td><%=HTML.encodeTags(qt.getName())%></td>
													<td><%=Values.formatBytes(summary.getTotal(qt))%></td>
													<%
													if (hasLocation)
													{
														%>
														<td><%=Values.formatBytes(summary.getTotal(qt, Location.PRIMARY))%></td>
														<td><%=qt.hasSecondaryLocation() ? Values.formatBytes(summary.getTotal(qt, Location.SECONDARY)) : "n/a"%></td>
														<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.OFFLINE)) : "n/a"%></td>
														<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.EXTERNAL)) : "n/a"%></td>
														<%
													}
													%>
												</tr>
												<%
											}
										}
										%>
										</table>
										<%
									}
									else
									{
										%>
										&nbsp;<%=Values.formatBytes(total)%>
										<%
									}
									if (total > 0)
									{
										%>
										<base:icon image="gonext.png" 
											onclick="<%="viewDiskUsageDetails(" + itemId + ")"%>">View details</base:icon>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="quota"
									><base:propertyvalue 
										item="<%=item%>" 
										property="quota"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
						if (numListed == 0)
						{
							%>
							<tbl:panel clazz="messagepanel">
								<div class="messagecontainer note">
								<%=groups == null || groups.getTotalCount() == 0 ? "No groups were found" : "No groups on this page. Please select another page!" %>
								</div>
							</tbl:panel>
							<%
						}
						%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (groups != null) groups.close();
	if (dc != null) dc.close();
}
%>
