<%-- $Id: ajax.jsp 6109 2012-09-07 08:06:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.InvalidDataException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.List"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetRelatedSubtype".equals(cmd))
	{
		Item relatedType = Item.valueOf(request.getParameter("relatedType"));
		int defaultRelatedId = Values.getInt(request.getParameter("defaultRelatedId"));
		dc = sc.newDbControl();
		ItemSubtype related = null;
		if (itemId > 0)
		{
			ItemSubtype subtype = ItemSubtype.getById(dc, itemId);
			related = subtype.getRelatedSubtype(relatedType);
		}
		if (related == null && defaultRelatedId > 0)
		{
			related = ItemSubtype.getById(dc, defaultRelatedId);
		}
		if (related != null)
		{
			json.put("id", related.getId());
			json.put("name", related.getName());
		}
		dc.close();
	}
	else if ("GetSubtypeForItem".equals(cmd))
	{
		Item itemType = Item.valueOf(request.getParameter("itemType"));
		dc = sc.newDbControl();
		Subtypable item = (Subtypable)itemType.getById(dc, itemId);
		ItemSubtype subtype = item.getItemSubtype();
		if (subtype != null)
		{
			json.put("id", subtype.getId());
			json.put("name", subtype.getName());
		}
		dc.close();
	}
	else if ("GetRecentAndRelated".equals(cmd))
	{
		dc = sc.newDbControl();

		// The main item's subtype
		ItemSubtype subtype = itemId == 0 ? null : ItemSubtype.getById(dc, itemId);
		Item mainItemType = null;
		if (subtype != null)
		{
			mainItemType = subtype.getMainItemType();
			json.put("id", subtype.getId());
			json.put("name", subtype.getName());
		}
		else
		{
			mainItemType = Item.valueOf(request.getParameter("itemType"));
		}

		// Current context for the main item
		ItemContext cc = sc.getCurrentContext(mainItemType);

		// Active project
		Project activeProject = sc.getActiveProjectId() > 0 ? Project.getById(dc, sc.getActiveProjectId()) : null;
		
		// Related item types
		for (String relatedType : request.getParameterValues("relatedType"))
		{
			JSONObject jsonITEM = new JSONObject();
			Item relatedItem = Item.valueOf(relatedType);
			
			// Load the related subtype
			ItemSubtype relatedSubtype = null;
			if (subtype != null)
			{
				relatedSubtype = subtype.getRelatedSubtype(relatedItem);
				if (relatedSubtype != null)
				{
					JSONObject jsonRelated = new JSONObject();
					jsonRelated.put("id", relatedSubtype.getId());
					jsonRelated.put("name", relatedSubtype.getName());
					jsonITEM.put("related", jsonRelated);
				}
			}
			
			if (relatedSubtype == null)
			{
				// Find a default related subtype
				String systemId = null;
				if (relatedItem == Item.PROTOCOL)
				{
					systemId = Protocol.getDefaultSystemId(mainItemType);
				}
				else if (relatedItem == Item.HARDWARE)
				{
					systemId = Hardware.getDefaultSystemId(mainItemType);
				}
				else if (relatedItem == Item.SOFTWARE)
				{
					systemId = Software.getDefaultSystemId(mainItemType);
				}
				if (systemId != null) 
				{
					relatedSubtype = ItemSubtype.getById(dc, SystemItems.getId(systemId));
				}
			}
			
			// Load the most recently used items
			List<? extends BasicItem> recentItems = cc.getRecent(dc, relatedItem, subtype);
			if (recentItems != null && recentItems.size() > 0)
			{
				JSONArray jsonRecent = new JSONArray();
				for (BasicItem recent : recentItems)
				{
					JSONObject jsonRecentItem = new JSONObject();
					jsonRecentItem.put("id", recent.getId());
					jsonRecentItem.put("name", ((Nameable)recent).getName());
					jsonRecent.add(jsonRecentItem);
				}
				jsonITEM.put("recent", jsonRecent);
			}
			
			// Load project default items
			if (activeProject != null)
			{
				List<? extends BasicItem> defaultItems = relatedSubtype != null ?
						activeProject.findDefaultItems(dc, relatedSubtype, false) : activeProject.findDefaultItems(dc, relatedItem, true);
						
				JSONArray jsonDefault = new JSONArray();
				for (BasicItem defaultItem : defaultItems)
				{
					JSONObject jsonDefaultItem = new JSONObject();
					jsonDefaultItem.put("id", defaultItem.getId());
					jsonDefaultItem.put("name", ((Nameable)defaultItem).getName());
					jsonDefault.add(jsonDefaultItem);
				}
				jsonITEM.put("default", jsonDefault);
			}
			
			json.put(relatedType, jsonITEM);
		}
		dc.close();
	}
	else if ("GetRecentAndDefault".equals(cmd))
	{
		dc = sc.newDbControl();

		// The subtype
		ItemSubtype subtype = itemId == 0 ? null : ItemSubtype.getById(dc, itemId);
		if (subtype != null)
		{
			json.put("id", subtype.getId());
			json.put("name", subtype.getName());
		}

		Item mainItemType = request.getParameter("itemType") == null ? null : Item.valueOf(request.getParameter("itemType"));
		// Current context for the main item
		if (mainItemType != null)
		{
			ItemContext cc = sc.getCurrentContext(mainItemType);
	
			// Load the most recently used items
			List<? extends BasicItem> recentItems = cc.getRecent(dc, subtype == null ? mainItemType : subtype.getMainItemType(), subtype);
			if (recentItems != null && recentItems.size() > 0)
			{
				JSONArray jsonRecent = new JSONArray();
				for (BasicItem recent : recentItems)
				{
					JSONObject jsonRecentItem = new JSONObject();
					jsonRecentItem.put("id", recent.getId());
					jsonRecentItem.put("name", ((Nameable)recent).getName());
					jsonRecent.add(jsonRecentItem);
				}
				json.put("recent", jsonRecent);
			}
		}
				
		// Load project default items for active project
		if (sc.getActiveProjectId() > 0)
		{
			Project activeProject = Project.getById(dc, sc.getActiveProjectId());
			
			List<? extends BasicItem> defaultItems = subtype == null ? 
					activeProject.findDefaultItems(dc, mainItemType, true) :
					activeProject.findDefaultItems(dc, subtype, true);
					
			JSONArray jsonDefault = new JSONArray();
			for (BasicItem defaultItem : defaultItems)
			{
				JSONObject jsonDefaultItem = new JSONObject();
				jsonDefaultItem.put("id", defaultItem.getId());
				jsonDefaultItem.put("name", ((Nameable)defaultItem).getName());
				jsonDefault.add(jsonDefaultItem);
			}
			json.put("default", jsonDefault);
		}
		
		dc.close();
	}

	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>