<%-- $Id: edit_subtype.jsp 5983 2012-02-23 14:45:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@since 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemSubtypeFileType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ITEMSUBTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ItemSubtype subtype = null;
	ItemQuery<ItemSubtypeFileType> fileTypesQuery = null;
	
	if (itemId == 0)
	{
		title="Create item subtype";
		cc.removeObject("item");
	}
	else
	{
		subtype = ItemSubtype.getById(dc, itemId);
		cc.setObject("item", subtype);
		title = "Edit item subtype -- " + HTML.encodeTags(subtype.getName());
		subtype.checkPermission(Permission.WRITE);
		fileTypesQuery = subtype.getDataFileTypes();
	}
	
	Set<Item> subtypableItems = Metadata.getSubtypableItems();
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), subtype);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Item subtype" tab
		function validateItemSubtype()
		{
			var frm = document.forms['subtype'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['subtype'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.modifiedFileTypes.value = Link.exportModified(frm, 'F', true).join(',');
				frm.removedFileTypes.value = Link.getActionIds(-1, 'F').join(',');
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (subtype == null)
			{
				%>
				var frm = document.forms['subtype'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initFileTypes();
			mainItemOnChange();
		}
		
		function initFileTypes()
		{
			var frm = document.forms['subtype'];
			var fileTypes = frm.fileTypes;
			<%
			if (fileTypesQuery != null)
			{
				fileTypesQuery.include(Include.ALL);
				fileTypesQuery.order(Orders.asc(Hql.property("itemSubtype.name")));
				for (ItemSubtypeFileType ft : fileTypesQuery.list(dc))
				{
					DataFileType dft = ft.getDataFileType();
					boolean required = ft.isRequired();
					boolean multiple = ft.getAllowMultiple();
					int value = 0;
					if (required) value += 1;
					if (multiple) value += 2;
					%>
					Link.addNewItem(fileTypes, new Item('F', <%=dft.getId()%>, '<%=HTML.javaScriptEncode(dft.getName())%> <%=required ? "[×]" : "[-]"%>', <%=value%>));
					<%
				}
			}
			%>
		}
		
		var itemInfo = new Array();
		<%
		for (Item item : subtypableItems)
		{
			String tmp = "";
			for (Item related : ItemSubtype.getRelatedItems(item))
			{
				tmp += related.name() + ":";
			}
			%>
			var info = new Object();
			info.value = <%=item.getValue()%>;
			info.related = '<%=tmp%>';
			info.fileStoreEnabled = <%=FileStoreEnabled.class.isAssignableFrom(item.getItemClass()) ? "true" : "false"%>;
			info.supportsPushAnnotations = <%=ItemSubtype.supportsPushAnnotations(item) ? "true" : "false" %>;
			itemInfo['<%=item.name()%>'] = info;
			<%
		}
		%>
		
		function getCurrentMainItemType()
		{
			var frm = document.forms['subtype'];
			<%
			if (subtype != null)
			{
				%>
				var mainType = '<%=subtype.getMainItemType().name()%>';
				<%
			}
			else
			{
				%>
				var mainType = frm.itemType[frm.itemType.selectedIndex].value;
				<%
			}
			%>
			return mainType;
		}
		
		function mainItemOnChange()
		{
			var mainType = getCurrentMainItemType();
			<%
			for (Item item : subtypableItems)
			{
				%>
				Main.showHide('section.<%=item.name()%>', itemInfo[mainType].related.indexOf('<%=item.name()%>') >= 0)
				<%
			}
			%>
			Main.showHide('section.none', itemInfo[mainType].related == '')
			if (itemInfo[mainType].fileStoreEnabled)
			{
				Main.show('filetypes.enabled');
				Main.hide('filetypes.disabled');
			}
			else
			{
				Main.hide('filetypes.enabled');
				Main.show('filetypes.disabled');
				document.getElementById('filetypes.disabled').innerHTML = '<div class="messagecontainer error">The selected main item type (' + mainType + ') has not support for attaching data files.</div>';
			}
			Main.showHide('section.pushAnnotations', itemInfo[mainType].supportsPushAnnotations);
		}
		
		var lastList;
		function relatedItemOnSelect(itemType)
		{
			var frm = document.forms['subtype'];
			lastList = frm['related.'+itemType];
			var url = 'index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&title=Select+related+subtype&callback=setRelatedCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemType=' + itemInfo[itemType].value;
			if (lastList.length > 1) 
			{
				var id = Math.abs(parseInt(lastList[1].value));				
				url += '&item_id='+id;
			}
			url += '&exclude=<%=itemId%>';
			Main.openPopup(url, 'SelectReleatedSubtype', 1050, 700);
		}
		function setRelatedCallback(id, name)
		{
			var frm = document.forms['subtype'];
			var list = lastList;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function addFileTypesOnClick()
		{
			var frm = document.forms['subtype'];
			var itemType = getCurrentMainItemType();
			var ids = Link.getListIds(frm.fileTypes, 'F');
			var excludes = ids.join(',');
			var url = '../../admin/datafiletypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addFileTypeCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemType=' + itemInfo[itemType].value;
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddFileTypes', 1050, 700);
		}
		function addFileTypeCallback(fileTypeId, name)
		{
			var item = Link.getItem('F', fileTypeId);
			var frm = document.forms['subtype'];
			var required = frm.required.checked;
			var multiple = frm.multiple.checked;
			var newValue = 0;
			if (required) newValue += 1;
			if (multiple) newValue += 2;
			if (!item) item = new Item('F', fileTypeId, name+(required ? '[×]' : '[-]'), newValue, '');
			Link.addItem(frm.fileTypes, item);
		}

		function removeFileTypesOnClick()
		{
			Link.removeSelected(document.forms['subtype'].fileTypes);
		}
		function fileTypesOnChange()
		{
			var frm = document.forms['subtype'];
			var item = frm.fileTypes[frm.fileTypes.selectedIndex].item;
			if (item && item.id)
			{
				frm.required.checked = (item.value & 1) > 0;
				frm.multiple.checked = (item.value & 2) > 0;
			}
			else
			{
				frm.required.checked = false;
				frm.multiple.checked = false;
			}
		}

		function requiredOnClick()
		{
			var frm = document.forms['subtype'];
			var required = frm.required.checked;
			var multiple = frm.multiple.checked;
			var newValue = 0;
			if (required) newValue += 1;
			if (multiple) newValue += 2;
			for (var i = 0; i < frm.fileTypes.length; i++)	// >
			{
				var option = frm.fileTypes[i];
				if (option.selected && option.item.id)
				{
					option.item.value = newValue;
					var text = option.text.replace(/\[.*\]/, '['+(required ? '×' : '-') +']');
					option.text = text; 
				}
			}
		}
		function multipleOnClick()
		{
			requiredOnClick();
		}

		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="subtype" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=subtype != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Item subtype" validate="validateItemSubtype()" helpid="itemsubtype.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(subtype == null ? Values.getString(cc.getPropertyValue("name"), "New item subtype") : subtype.getName())%>" 
					maxlength="<%=ItemSubtype.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Main item type</th>
				<td>
					<%
					if (subtype == null)
					{
						%>
						<select name="itemType" class="required unchangeable selectionlist" onchange="mainItemOnChange()">
						<%
						int itemCode = Values.getInt(cc.getPropertyValue("itemType"), -1);
						for (Item item : subtypableItems)
						{
							String selected = itemCode == item.getValue() ? "selected" : "";
							%>
							<option value="<%=item.name()%>" <%=selected%>><%=item.toString() %>
							<%
						}
						%>
						</select>
						<%
					}
					else
					{
						%>
						<%=subtype.getMainItemType() %>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr id="section.pushAnnotations">
				<th></th>
				<td><input type="checkbox" name="pushAnnotations" 
					id="pushAnnotations" value="1" 
					<%=(subtype != null && subtype.getPushAnnotations()) || 
						(subtype == null && Values.getBoolean(cc.getPropertyValue("pushAnnotations"))) ? "checked" : ""%>
					><label for="pushAnnotations">Push annotations to parent</label></td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" name="description" 
						><%=HTML.encodeTags(subtype == null ? cc.getPropertyValue("description") : subtype.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'subtype', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			<tr>
				<th>Related subtypes</td>
				<td><div id="section.none" style="display: none;"><i>- none -</i></div></td>
				<td></td>
			</tr>
			<%
			for (Item item : subtypableItems)
			{
				%>
				<tr id="section.<%=item.name()%>" style="display: none;">
					<th class="subprompt"><%=item%></th>
					<td>
						<base:select 
							id="<%="related."+item.name()%>" 
							current="<%=subtype == null ? null : subtype.getRelatedSubtype(item) %>"
							onselect="<%="relatedItemOnSelect('" + item.name() + "')"%>"
							newitem="<%=subtype == null%>"
							clazz="selectionlist"
						/>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</t:tab>
		<t:tab
			id="filetypes"
			title="File types"
			helpid="itemsubtype.filetypes">
			<div id="filetypes.enabled" style="height: 100%; display: none;">
				<table class="fullform input100">
				<tr class="dynamic">
					<th>File types</th>
					<td>
						<div class="selectionlist">
							<table>
							<tr>
							<td>
								<select name="fileTypes" size="10" multiple onchange="fileTypesOnChange()">
								</select>
								<input type="hidden" name="modifiedFileTypes" value="">
								<input type="hidden" name="removedFileTypes" value="">
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										subclass="leftaligned"
										style="width: 14em;"
										onclick="addFileTypesOnClick()" 
										title="Add file types&hellip;" 
										tooltip="Add file types"
										/>
									<base:button 
										subclass="leftaligned"
										style="width: 14em;"
										onclick="removeFileTypesOnClick()" 
										title="Remove" 
										tooltip="Remove the selected file types"
									/>
								</base:buttongroup>
								<input type="checkbox" id="required" name="required" value="1" onchange="requiredOnClick()">
									<label for="required">Required</label><br>
								<input type="checkbox" id="multiple" name="multiple" value="1" onchange="multipleOnClick()">
									<label for="multiple">Allow multiple files</label>
								</td>
							</tr>
							</table>
						</div>
					</td>
				</tr>
				</table>
			</div>
			<div id="filetypes.disabled" style="display: none; border: 1px solid transparent;">
				<div class="messagecontainer error"></div>
			</div>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
