<%-- $Id: create_child_bioplate_step1.jsp 6056 2012-06-12 08:41:44Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Tag"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final int sourcePlateId = Values.getInt(request.getParameter("sourceplate_id"));
final ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.CREATE_BIOMATERIAL);
final DbControl dc = sc.newDbControl();
try
{
	BioPlate sourcePlate = BioPlate.getById(dc, sourcePlateId);
	BioPlateType sourceType = sourcePlate.getBioPlateType();
	Item sourceBioMaterialType = sourceType.getBioMaterialType();
	PlateGeometry sourceGeometry = sourcePlate.getPlateGeometry();
	Hardware sourceFreezer = sourcePlate.getFreezer();
	
	// Load recently used items
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, sourceBioMaterialType.name());
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, sourceBioMaterialType.name());
	List<PlateGeometry> recentGeometry = (List<PlateGeometry>)cc.getRecent(dc, Item.PLATEGEOMETRY, sourceBioMaterialType.name());
	List<BioPlateType> recentPlateTypes = (List<BioPlateType>)cc.getRecent(dc, Item.BIOPLATETYPE, sourceBioMaterialType.name());
	List<Hardware> recentFreezers = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, "freezer");
	
	// Load subtypes
	final List<ItemSubtype> sampleSubtypes = sourceBioMaterialType == Item.SAMPLE ? 
		Base.getSubtypesQuery(Item.SAMPLE).list(dc) : null;
	final List<ItemSubtype> extractSubtypes = Base.getSubtypesQuery(Item.EXTRACT).list(dc);
	final List<ItemSubtype> bioAssaySubtypes = sourceBioMaterialType == Item.EXTRACT ? 
		Base.getSubtypesQuery(Item.PHYSICALBIOASSAY).list(dc) : null;
	// Find a common itemsubtype (if any)
	ItemSubtype commonSubtype = null;
	boolean first = true;
	for (BioWell well : sourcePlate.getBioWells().list(dc))
	{
		try
		{
			if (!well.isEmpty())
			{
				ItemSubtype subtype = well.getBioMaterial().getItemSubtype();
				if (first)
				{
					commonSubtype = subtype;
					first = false;
				}
				else
				{
					if (subtype == null || !subtype.equals(commonSubtype))
					{
						commonSubtype = null;
						break;
					}
				}
			}
		}
		catch (PermissionDeniedException ex)
		{}
	}
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final String dateFormat = FormatterSettings.getDateFormat(sc);
	final String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	final String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>
	<base:page type="popup" title="Create child bioplate - step 1/2">
	<base:head scripts="subtypes.js,ajax.js">
		<script language="javascript">
	
		function nextStep()
		{
			var frm = document.forms['main'];
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			if (Main.trimString(frm.event_name.value) == '')
			{
				alert("You must enter a name for the new event.");
				frm.event_name.focus();
				return;
			}
			if (Main.trimString(frm.number_of_plates.value) == '')
			{
				alert("You must enter the number of plates that was created.");
				frm.number_of_plates.focus();
				return;
			}
			if (Main.trimString(frm.plate_name_prefix.value) == '')
			{
				alert("You must enter a name prefix for the new plates.");
				frm.plate_name_prefix.focus();
				return;
			}
			if (frm.plategeometry_id.length == 0 && childType != 'PHYSICALBIOASSAY')
			{
				alert("You must select a plate geometry");
				frm.plategeometry_id.focus();
				return false;
			}
			if (frm.bioplatetype_id.length == 0 && childType != 'PHYSICALBIOASSAY')
			{
				alert("You must select a plate type");
				frm.bioplatetype_id.focus();
				return false;
			}
			frm.submit();
			
		}
			
		function selectHardwareOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setHardwareCallback';
			if (frm.hardware_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1';
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			url += ItemSubtype.createRelatedFilter('main', 'HARDWARE', '', childType+'_subtype_id');
			Main.openPopup(url, 'SelectHardware', 1050, 700); 
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
	
		function selectProtocolOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			url += '&resetTemporary=1';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			url += ItemSubtype.createRelatedFilter('main', 'PROTOCOL', '', childType+'_subtype_id');
			Main.openPopup(url, 'SelectProtocol', 1050, 700); 
		}

		function setProtocolCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function selectTagOnClick()
		{
			var frm = document.forms['main'];
			var url = '../tags/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setTagCallback';
			url += '&resetTemporary=1';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			url += ItemSubtype.createRelatedFilter('main', 'TAG', '', childType+'_subtype_id');
			Main.openPopup(url, 'SelectTag', 1050, 700); 
		}

		function setTagCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.tag_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		
		function selectPlateGeometryOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../lims/geometries/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPlateGeometryCallback';
			if (frm.plategeometry_id.length > 0) url += '&item_id='+frm.plategeometry_id[0].value;
			url += '&resetTemporary=1';
			Main.openPopup(url, 'SelectPlateGeometry', 1050, 700);
		}
		function setPlateGeometryCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.plategeometry_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}

		var bioMaterialTypes = { 'EXTRACT': <%=Item.EXTRACT.getValue()%>, 'SAMPLE': <%=Item.SAMPLE.getValue()%> };
		function selectBioPlateTypeOnClick()
		{
			var frm = document.forms['main'];
			var url = '../bioplatetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioPlateTypeCallback';
			if (frm.bioplatetype_id.length > 0) url += '&item_id='+frm.bioplatetype_id[0].value;
			
			url += '&resetTemporary=1';
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value; 
			// Restrict to plates that can holds to target biomaterial
			url += '&tmpfilter:INT:bioMaterialType=|'+bioMaterialTypes[childType];
			var subtypeId = ItemSubtype.getSubtypeId('main', childType+'_subtype_id');
			// Restrict to plates with the given subtype
			url += '&tmpfilter:INT:itemSubtype='+(subtypeId ? '|' + subtypeId : '=');
		
			Main.openPopup(url, 'SelectBioPlateType', 1050, 700);
		}
		function setBioPlateTypeCallback(bioPlateTypeId, name)
		{
			var frm = document.forms['main'];
			var list = frm.bioplatetype_id;
			if (list.length < 1 || list[0].disabled) // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = bioPlateTypeId;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		function selectFreezerOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setFreezerCallback';
			if (frm.freezer_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.freezer_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:itemSubtype=<%=SystemItems.getId(Hardware.FREEZER)%>';
			Main.openPopup(url, 'SelectFreezer', 1050, 700); 
		}
		function setFreezerCallback(freezerId, name)
		{
			var frm = document.forms['main'];
			if (frm.freezer_id.length < 2) // >
			{
				frm.freezer_id[frm.freezer_id.length] = new Option();
			}
			frm.freezer_id[1].value = freezerId;
			frm.freezer_id[1].text = name;
			frm.freezer_id.selectedIndex = 1;
		}
		function childTypeOnChange()
		{
			var frm = document.forms['main'];
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			var isSample = childType == 'SAMPLE';
			var isExtract = childType == 'EXTRACT';
			var isBioAssay = childType == 'PHYSICALBIOASSAY';
			Main.showHide('sampleSubtypesDiv', isSample);
			Main.showHide('extractSubtypesDiv', isExtract);
			Main.showHide('bioAssaySubtypesDiv', isBioAssay);
			Main.showHide('tagDiv', isExtract);
			Main.showHide('originalQuantityDiv', !isBioAssay);
			Main.showHide('freezerDiv', !isBioAssay);
			Main.showHide('plateTypeDiv', !isBioAssay);
			Main.showHide('geometryDiv', !isBioAssay);
			Main.showHide('sizeDiv', isBioAssay);
		}
		
		function init()
		{
			childTypeOnChange();
		}
		
		</script>
	</base:head>
	<base:body onload="init()">
		<h1>Create child bioplate - step 1/2 <base:help helpid="bioplateevent.create-child-1" /></h1>
		<form name="main" action="create_child_bioplate_step2.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="sourceplate_id" value="<%=sourcePlateId%>">

		<div class="content bottomborder">
			<table class="fullform input100">
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Event</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Event name</th>
					<td><input <%=requiredClazz%> type="text" name="event_name" 
						value="Create child plate" 
						maxlength="<%=BioPlateEvent.MAX_NAME_LENGTH%>">
					</td>
					<td rowspan="4">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea <%=clazz%> rows="4" name="event_description" 
								></textarea>
						</td>
						<td style="width: 20px;">
							<base:icon 
								image="zoom.png" 
								onclick="Main.zoom('Event description', 'main', 'event_description')"
								tooltip="Edit in larger window"
							/>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Event date</th>
					<td>
						<table>
						<tr>
						<td>
							<input <%=clazz%> type="text" name="event_date" style="width: 15em;"
								value="<%=HTML.encodeTags(dateFormatter.format(new Date()))%>" 
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
						<base:button 
							onclick="<%="Dates.selectDate('Event date', 'main', 'event_date', null, '"+jsDateFormat+"')"%>"
							image="calendar.png"
							title="Calendar&hellip;" 
							tooltip="Select a date from a calendar" 
						/>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Protocol</th>
					<td>
						<base:select 
							id="protocol_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentProtocols%>"
							onselect="selectProtocolOnClick()"
						/>
					</td>
				</tr>
				<tr>
					<th>Hardware</th>
					<td>
						<base:select 
							id="hardware_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentHardware%>"
							onselect="selectHardwareOnClick()"
						/>
					</td>
				</tr>
			</tbody>

			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Child biomaterial</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Type</th>
					<td>
						<select name="child_biomaterial_type" class="required selectionlist" onchange="childTypeOnChange()">
							<%
							if (sourceBioMaterialType == Item.SAMPLE)
							{
								%>
								<option value="SAMPLE">Sample → Sample
								<option value="EXTRACT" selected>Sample → Extract
								<%
							}
							else if (sourceBioMaterialType == Item.EXTRACT)
							{
								%>
								<option value="EXTRACT">Extract → Extract
								<option value="PHYSICALBIOASSAY" selected>Extract → Physical bioassay
								<%
							}
							%>
						</select>
					</td>
					<td rowspan="5">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea <%=clazz%> rows="4" name="child_description"></textarea>
						</td>
						<td style="width: 20px;">
							<base:icon 
								image="zoom.png" 
								onclick="Main.zoom('Biomaterial description', 'main', 'child_description')"
								tooltip="Edit in larger window"
							/>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<%
				if (sampleSubtypes != null && sampleSubtypes.size() > 0)
				{
					%>
					<tr id="sampleSubtypesDiv" style="display: none;">
						<th>Subtype</th>
						<td>
							<select name="SAMPLE_subtype_id" class="selectionlist">
								<option value="0">- none -
								<%
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.SAMPLE);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : sampleSubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
								%>
							</select>
						</td>
					</tr>
					<%
				}
				if (extractSubtypes != null && extractSubtypes.size() > 0)
				{
					%>
					<tr id="extractSubtypesDiv" style="display: none;">
						<th>Subtype</th>
						<td>
							<select name="EXTRACT_subtype_id" class="selectionlist">
								<option value="0">- none -
								<%
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.EXTRACT);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : extractSubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
								%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				<%
				if (bioAssaySubtypes != null && bioAssaySubtypes.size() > 0)
				{
					%>
					<tr id="bioAssaySubtypesDiv" style="display: none;">
						<th>Subtype</th>
						<td>
							<select name="PHYSICALBIOASSAY_subtype_id" class="selectionlist">
								<option value="0">- none -
								<%
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.PHYSICALBIOASSAY);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : bioAssaySubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
								%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				<tr id="tagDiv" style="display: none;">
					<th>Tag</th>
					<td>
						<base:select 
							id="tag_id"
							clazz="selectionlist"
							required="false"
							unselectedtext="<%=sourceBioMaterialType == Item.SAMPLE ? "- none -" : "- same as parent -" %>"
							current="<%=null%>"
							onselect="selectTagOnClick()"
						/>
					</td>
				</tr>
				<tr id="originalQuantityDiv">
					<th>Original quantity</th>
					<td><input <%=clazz%> type="text" name="original_quantity" style="width: 15em;"
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
				</tr>
				<tr>
					<th>Used from parent</th>
					<td><input <%=clazz%> type="text" name="used_quantity" style="width: 15em;"
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Child plates</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>No. of plates</th>
					<td><input <%=requiredClazz%> type="text" name="number_of_plates" value="1" 
						maxlength="2" style="width: 15em;"
						onkeypress="return Numbers.integerOnly(event)"></td>
					<td rowspan="5">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea <%=clazz%> rows="4" name="plate_description"></textarea>
						</td>
						<td style="width: 20px;">
							<base:icon 
								image="zoom.png" 
								onclick="Main.zoom('Plate description', 'main', 'plate_description')"
								tooltip="Edit in larger window"
							/>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Name prefix</th>
					<td><input <%=requiredClazz%> type="text" name="plate_name_prefix" 
						value="New plate." 
						maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
				</tr>
				<tr id="geometryDiv">
					<th>Geometry</th>
					<td>
						<base:select 
							id="plategeometry_id"
							clazz="selectionlist"
							required="true"
							current="<%=sourceGeometry%>"
							recent="<%=recentGeometry%>"
							newitem="true"
							onselect="selectPlateGeometryOnClick()"
						/>
					</td>
				</tr>
				<tr id="sizeDiv" style="display: none;">
					<th>Size of bioassay</th>
					<td><input <%=requiredClazz%> type="text" name="size" style="width: 15em;"
						value="<%=sourceGeometry.getRows() %>"
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"></td>
				</tr>
				<tr id="plateTypeDiv">
					<th>Plate type</th>
					<td>
						<base:select 
							id="bioplatetype_id"
							clazz="selectionlist"
							required="true"
							current="<%=null%>"
							recent="<%=recentPlateTypes%>"
							newitem="true"
							onselect="selectBioPlateTypeOnClick()"
						/>
					</td>
				</tr>
				<tr id="freezerDiv">
					<th>Storage location</th>
					<td>
						<base:select 
							id="freezer_id"
							clazz="selectionlist"
							required="false"
							current="<%=sourceFreezer%>"
							recent="<%=recentFreezers%>"
							newitem="true"
							onselect="selectFreezerOnClick()"
							onchange="freezerOnChange()"
						/>
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="nextStep()" title="Next" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>