<%-- $Id: list_annotations.jsp 6037 2012-03-29 09:50:36Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotatableProxy"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.NameableComparator"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.PrefixSuffixFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.TreeSet"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

Set<AnnotationType> annotationTypes = null;
Set<AnnotationType> protocolParameters = null;
Map<AnnotationType, AnnotationSnapshot> existing = null;

try
{
	final Annotatable item = (Annotatable)itemType.getById(dc, itemId);
	final boolean writePermission = item.hasPermission(Permission.WRITE);
	final SnapshotManager manager = new SnapshotManager();
	
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	String message = null;
	boolean isProxy = item instanceof AnnotatableProxy;

	// Load all annotation types that are possible for this item type
	if (isProxy)
	{
		AnnotatableProxy proxy = (AnnotatableProxy)item;
		annotationTypeQuery = Base.getAnnotationTypesQuery(proxy);
		message = proxy.getAnnotationMessage();
	}
	else
	{
		annotationTypeQuery = Base.getAnnotationTypesQuery(itemType, false);
	}
	annotationTypes = new TreeSet<AnnotationType>(new NameableComparator(false));
	annotationTypes.addAll(annotationTypeQuery.list(dc));

	final AnnotationSetSnapshot snapshot = item.isAnnotated() ? 
			manager.getSnapshot(dc, item.getAnnotationSet().getId()) : null;
	List<AnnotationSnapshot> inheritedAnnotations = null;
	if (snapshot != null)
	{
		// Load the existing primary and inherited annotations
		existing = new HashMap<AnnotationType, AnnotationSnapshot>();
		inheritedAnnotations = new ArrayList<AnnotationSnapshot>();
		for (AnnotationSnapshot a : manager.findAnnotations(dc, snapshot, null, true))
		{
			AnnotationType at = a.getAnnotationType(dc);
			if (!a.isInherited())
			{
				existing.put(a.getAnnotationType(dc), a);
			}
			else
			{
				inheritedAnnotations.add(a);
			}
		}
		annotationTypes.addAll(existing.keySet());
	}
	
	// Load the possible protocol parameters
	Protocol protocol = null;
	boolean readProtocol = true;
	try
	{
		protocol = item.getProtocol();
	}
	catch (PermissionDeniedException ex)
	{
		readProtocol = false;
	}
	ItemQuery<AnnotationType> parameterQuery = Base.getProtocolParametersQuery(protocol);
	if (parameterQuery != null)
	{
		protocolParameters = new HashSet<AnnotationType>(parameterQuery.list(dc));
		annotationTypes.removeAll(protocolParameters);
	}
	%>
	<base:page type="include">
	<base:body>
		<script language="JavaScript">
		function editAnnotation(annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
			url += '&item_type=<%=itemType.name()%>';
			url += '&item_id=<%=itemId%>';
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 750, 500);
		}
		function editInheritedAnnotation(itemType, itemId, annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
			url += '&item_type='+itemType;
			url += '&item_id='+itemId;
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 750, 500);
		}
		</script>
		<%
		if (message != null)
		{
			%>
			<div class="messagecontainer note"><%=message%></div>
			<%
		}
		%>
		<base:section
			id="primaryAnnotations"
			title="<%="Primary annotations (" + annotationTypes.size() + ")"%>"
			>
			<%
			if (annotationTypes.size() == 0)
			{
				%>
				<div class="messagecontainer note">
				No annotation types has been defined for this type of item 
				(or you don't have permission to view them).
				</div>
				<%
			}
			else
			{
				%>
				<tbl:table
					id="annotations"
					columns="all"
					>
					<tbl:columndef 
						id="annotation"
						title="Annotation"
					/>
					<tbl:columndef 
						id="values"
						title="Values"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (AnnotationType at : annotationTypes)
						{
							AnnotationSnapshot a = existing != null ? existing.get(at) : null;
							List<?> values = null;
							Formatter formatter = null;
							if (a != null)
							{
								Annotation ann = a.getAnnotation(dc);
								values = a.getValues(ann.getUnitConverter(null), ann.getValueType());
								formatter = FormatterFactory.getAnnotationFormatter(sc, ann, null);
							}
							if (values != null || !at.isRemoved())
							{
							%>
								<tbl:row>
									<tbl:cell column="annotation"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=at.isRemoved()%>"
									/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
									<tbl:cell column="values"><%=values == null || values.size() == 0 ? "<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
									<%
										if (writePermission)
										{
											%>: <base:icon image="edit.png" 
												onclick="<%="editAnnotation("+at.getId()+")"%>" 
												tooltip="Modify the values of this annotation" />
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
								</tbl:row>
								<%
							}
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			%>
		</base:section>

		<%
		if (protocolParameters != null)
		{
			%>
			<base:section 
				id="parameterSection" 
				title="<%="Protocol parameters for " + HTML.encodeTags(protocol.getName()) + 
					" (" + protocolParameters.size() + ")"%>"
				>
				<%
				if (protocolParameters.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No protocol parameters has been defined for the protocol 
					<%=Base.getLinkedName(ID, protocol, !readProtocol, true)%> 
					(or you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="parameters"
						columns="all"
						>
						<tbl:columndef 
							id="parameter"
							title="Parameter"
						/>
						<tbl:columndef 
							id="values"
							title="Values"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (AnnotationType at : protocolParameters)
							{
								AnnotationSnapshot a = existing != null ? existing.get(at) : null;
								Formatter formatter = null;
								List<?> values = null;
								if (a != null)
								{
									Annotation ann = a.getAnnotation(dc);
									values = a.getValues(ann.getUnitConverter(null), ann.getValueType());
									formatter = FormatterFactory.getAnnotationFormatter(sc, ann, null);
								}
								if (values != null || !at.isRemoved())
								{
									%>
									<tbl:row>
										<tbl:cell column="parameter"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=at.isRemoved()%>"
										/><%=Base.getLinkedName(ID, at, false, true)%></tbl:cell>
										<tbl:cell column="values">
											<%=values == null || values.size() == 0 ? "<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
											<%
											if (writePermission)
											{
												%>: <base:icon image="edit.png" 
													onclick="<%="editAnnotation("+at.getId()+")"%>" 
													tooltip="Modify the values of this protocol parameter" />
												<%
											}
											%>
										</tbl:cell>
										<tbl:cell column="description"><%=HTML.encodeTags(at.getDescription())%></tbl:cell>
									</tbl:row>
									<%
								}
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<%
		}
		%>
		<%
		if (!isProxy)
		{
			int numInherited = inheritedAnnotations == null ? 0 : inheritedAnnotations.size();
			%>
			<base:section 
				id="inherited"
				title="<%="Inherited annotations and protocol parameters (" + numInherited + ")"%>"					
				>
				<%
				if (numInherited == 0)
				{
					%>
					<div class="messagecontainer note">
					No annotations are inherited by this item.
					(or you don't have permission to view them).
					</div>
					<%
				}
				else
				{
				%>
				<tbl:table
					id="inheritedAnnotations"
					columns="all"
					>
					<tbl:columndef 
						id="annotation"
						title="Annotation"
					/>
					<tbl:columndef 
						id="item"
						title="From item"
					/>
					<tbl:columndef 
						id="values"
						title="Values"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (AnnotationSnapshot a : inheritedAnnotations)
						{
							Annotation ann = a.getAnnotation(dc);
							AnnotationType at = a.getAnnotationType(dc);
							String name = HTML.encodeTags(at.getName());
							String description = HTML.encodeTags(at.getDescription());
							boolean writeInherited = false;
							String icon = "joust/annotation.gif";
							if (at.isRemoved())
							{
								icon = "deleted.png";
							}
							else if (at.isProtocolParameter())
							{
								icon = "parameter.png";
							}
							List<?> values = a.getValues(ann.getUnitConverter(null), ann.getValueType());
							Formatter formatter = FormatterFactory.getAnnotationFormatter(sc, ann, null);
							Nameable aItem = null;
							String fromType = a.getItemType().toString();
							try
							{
								aItem = (Nameable)a.getItem(dc);
								writeInherited = aItem.hasPermission(Permission.WRITE);
							}
							catch (PermissionDeniedException ex)
							{}
							if (aItem instanceof Subtypable)
							{
								try
								{
									ItemSubtype subtype = ((Subtypable)aItem).getItemSubtype();
									if (subtype != null) fromType = subtype.getName();
								}
								catch (PermissionDeniedException ex)
								{}
							}							%>
							<tbl:row>
								<tbl:cell column="annotation"><base:icon image="<%=icon%>" /><%=Base.getLinkedName(ID, at, at == null, true)%></tbl:cell>
								<tbl:cell column="item"><%=Base.getLinkedName(ID, aItem, aItem == null, true)%><%=aItem != null ? " <span class=\"itemsubtype\">("+fromType+")</span>" : ""%></tbl:cell>
								<tbl:cell column="values">
									<%=values == null || values.size() == 0 ? 
										"<i>- no values -</i>" : Values.getString(values, ", ", true, formatter)%>
									<%
									if (writeInherited && aItem != null)
									{
										%>: <base:icon image="edit.png" 
											onclick="<%="editInheritedAnnotation('"+aItem.getType().name()+"', "+aItem.getId()+", "+at.getId()+")"%>" 
											tooltip="Modify the values of this annotation" />
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="description"><%=description%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<base:icon image="joust/annotation.gif" /> = Annotation, 
				<base:icon image="parameter.png" /> = Protocol parameter 
				<%
			}
			%>
			</base:section>
			<%
		}
		%>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
