<%-- $Id: select_plugin.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ContextUtil"
	import="net.sf.basedb.util.ContextUtil.ContextResult"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
final GuiContext context = new GuiContext(itemType, contextType);
final String title = request.getParameter("title");
final boolean noAutodetect = Values.getBoolean(request.getParameter("noautodetect"));
final String message = request.getParameter("message");
final boolean anotherIsOpen = sc.getSessionSetting("plugin.configure.plugin") != null;
final DbControl dc = sc.newDbControl();
final float scale = Base.getScale(sc);
try
{
	final PluginType autoDetectingType = PluginType.getByInterfaceName(dc, AutoDetectingImporter.class.getName());

	String jobName = Values.getString(request.getParameter("job_name"), title);
	
	List<ContextResult> contextResults = (List<ContextResult>)sc.getSessionSetting("IMPORTERS");
	Set<String> messages = (Set<String>)sc.getSessionSetting("MESSAGES");
	StringBuilder descriptions = new StringBuilder();
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="plugin.js">
		<script language="JavaScript">
		function doNext()
		{
			var frm = document.forms['import'];
			var anotherIsOpen = <%=anotherIsOpen%>;
			if (anotherIsOpen)
			{
				if (!confirm('Are you sure? Unsaved settings in the other wizard will be lost.')) return;
				frm.warnIfOpen.value = '0';
			}
			frm.submit();
		}
		
		var lastSelectedPlugin;
		var lastSelectedConfig;
		function pluginOnChange()
		{
			var frm = document.forms['import'];
			var pluginList = frm.plugins;
			var plugin = pluginList[pluginList.selectedIndex].plugin;
			var config = pluginList[pluginList.selectedIndex].configuration;
			var selectedValue = pluginList[pluginList.selectedIndex].value;
			
			if (lastSelectedPlugin)
			{
				Main.hide('description.'+lastSelectedPlugin.id);
			}
			if (lastSelectedConfig)
			{
				Main.hide('description.config.'+lastSelectedConfig.id);
			}
			Main.showHide('descriptions', plugin);
			if (plugin)
			{
				Main.show('description.'+plugin.id);
				frm.plugindefinition_id.value = plugin.id;
				frm.pluginconfiguration_id.value = selectedValue == -1 ? -1 : 0;
			}
			else
			{
				frm.plugindefinition_id.value = selectedValue;
			}
			if (config)
			{
				Main.show('description.config.'+config.id);
				frm.pluginconfiguration_id.value = config.id;
			}
			lastSelectedConfig = config;
			lastSelectedPlugin = plugin;
		}

		function init()
		{
			var frm = document.forms['import'];
			var pluginList = frm.plugins;
			
			<%
			PluginDefinition lastPlugin = null;
			for (ContextResult result : contextResults)
			{
				if (result.isInContext())
				{
					PluginDefinition pd = result.getPluginDefinition();
					if (!pd.equals(lastPlugin))
					{
						lastPlugin = pd;
						dc.reattachItem(pd, false);
						boolean autoDetecting = !noAutodetect && pd.supports(autoDetectingType);
						String supportsConfig = pd.supportsConfigurations() ? "true" : "false";
						String requiresConfig = noAutodetect || pd.requiresConfiguration() ? "true" : "false";
						descriptions.append("<div id=\"description." + pd.getId() +"\" style=\"display: none;\">");
						descriptions.append(HTML.niceFormat("<b>" + pd.getName() + "</b>\n" + pd.getDescription()));
						descriptions.append("</div>");
						%>
						var thePlugin = new Plugin(<%=pd.getId()%>, '<%=HTML.javaScriptEncode(pd.getName())%>', <%=autoDetecting%>, <%=supportsConfig%>, <%=requiresConfig%>);
						<%
					}
					PluginConfiguration pc = result.getPluginConfiguration();
					if (pc != null)
					{
						descriptions.append("<div id=\"description.config." + pc.getId() + "\" style=\"display: none; padding-top: 6px;\">");
						descriptions.append(HTML.niceFormat("<b>" + pc.getName() + "</b>\n" +pc.getDescription()));						
						descriptions.append("</div>");
						%>
						thePlugin.addConfiguration(<%=pc.getId()%>, '<%=HTML.javaScriptEncode(pc.getName())%>');
						<%
					}
				}
			}
			%>			
			Plugins.populateLists(pluginList);
			pluginOnChange();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help helpid="import.selectplugin" /></h1>
		<form name="import" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="RunPlugin">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		<input type="hidden" name="context_type" value="<%=contextType.name()%>">
		<input type="hidden" name="title" value="<%=title%>">
		<input type="hidden" name="warnIfOpen" value="1">
		<input type="hidden" name="plugindefinition_id" value="">
		<input type="hidden" name="pluginconfiguration_id" value="">

		<div class="content bottomborder">
			<div class="absolutefull filled" style="height: 4.5em;">
				<table style="height: 100%; margin: auto;"><tr><td>
						<%
						if (anotherIsOpen)
						{
							%>
							<div class="messagecontainer error" style="margin: 0.2em; padding: 0.2em;">
								Another plug-in configuration wizard is open, or it hasn't properly 
								clean up after itself.<br>
								If you continue unsaved settings in the other wizard is lost.
							</div>
							<%
						}
						else
						{
							%>
							<%
							if (message != null)
							{
								%>
								<%=message%>
								<%
							}
							else
							{
								%>
								Please select a plugin and file format to use.
								<%
							}
							%>
						<%
						}
					%>
				</td></tr></table>
			</div>
			
			<div class="absolutefull topborder" style="top: 4.5em;">
				<table class="fullform">
				<tr>
					<th>Plugin + file format</th>
					<td>
						<select name="plugins" class="required" onchange="pluginOnChange()">
						</select>
						<%
						if (!noAutodetect)
						{
							%>
							× = Supports auto-detection
							<%
						}
						%>
					</td>
				</tr>
				<tr class="dynamic">
					<th></th>
					<td>
						<div id="descriptions" class="messagecontainer help" style="margin-left: 0px;">
						<%=descriptions.toString()%>
						</div>
					</td>
				</tr>
				<%
				if (messages != null && messages.size() > 0)
				{
					%>
					<tr class="big">
						<th></th>
						<td>
							<base:icon image="bullet.png" />
							<a href="javascript:Main.showHide('pluginMessages')" 
								title="Show/hide the messages from the plugins that couldn't be used">
							Some plugins couldn't be used
							</a>
							<div id="pluginMessages" style="display: none;">
							<ul>
							<li><%=Values.getString(messages, "<li>", true)%>
							</ul>
							</div>
						</td>
					</tr>
					<%
				}
				%>
				</table>
			</div>
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="doNext();" title="Next" />
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

