<%-- $Id: progress_reporter.jsp 5908 2011-12-13 13:48:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Display a progress reporter

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
	String title = Values.getString(request.getParameter("title"));
	String progressName = request.getParameter("progress");
	SessionControl sc = Base.getExistingSessionControl(pageContext, true);
	
	SimpleProgressReporter progress = (SimpleProgressReporter)sc.getSessionSetting("progress." + progressName);
	String message = null;
	int percentDone = 0;
	if (progress != null)
	{
		message = progress.getMessage();
		percentDone = progress.getPercent();
	}
	if (message == null)
	{
		message = "Please wait...";
	}
	String onload = "";
	if (percentDone >= 100)
	{
		onload = "setTimeout('window.close()', 1500)";
		sc.setSessionSetting("progress." + progressName, null);
	}
	else
	{
		onload = "setTimeout('location.reload()', 1500)";
	}
	
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="progressbar.css">
	<script>
	</script>
</base:head>
<base:body onload="<%=onload%>">
	<h1><%=title%></h1>
	<div class="content">
	
		<table class="fullcc"><tr><td>
			<table class="progressbar" style="margin: auto;">
			<tr>
			<td>
				<table id="bar" style="width: 200px;">
				<tr>
					<%if (percentDone > 0) {%><td style="width: <%=percentDone%>%;" id="percentDone">&nbsp;</td><%}%>
					<%if (percentDone < 100) {%><td style="width: <%=100-percentDone%>%;" id="percentRemain">&nbsp;</td><%}%>
				</tr>
				</table>
			</td>
				<td id="percentText"><%=percentDone%>%</td>
			</tr>
			</table>
			<%=message %>
			<br><br>
			
			<div align="center">
			<i>Closing this window will NOT abort the process</i>
			</div>
		</td></tr></table>
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="window.close()" title="Close" />
	</base:buttongroup>

</base:body>
</base:page>
