<%-- $Id: ajax.jsp 6109 2012-09-07 08:06:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.List"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetSubdirectories".equals(cmd))
	{
		dc = sc.newDbControl();
		Directory dir = Directory.getById(dc, itemId);
		
		ItemQuery<Directory> query = dir.getSubDirectories();
		query.include(Include.ALL);
		query.order(Orders.asc(Hql.property("name")));
		List<Directory> subdirs = query.list(dc);
		JSONArray jsonSubdirs = new JSONArray();
		for (Directory d : subdirs)
		{
			JSONObject jsonDir = new JSONObject();
			jsonDir.put("id", d.getId());
			jsonDir.put("name", d.getName());
			jsonDir.put("path", d.getPath().toString());
			jsonDir.put("isRemoved", d.isRemoved());
			jsonDir.put("isAutoCompress", d.getAutoCompress());
			jsonDir.put("isHome", d.isHomeDirectory());
			jsonSubdirs.add(jsonDir);
		}
		dc.commit();
		json.put("subdirs", jsonSubdirs);
	}
	else
	{
		throw new RuntimeException("Invalid command. The command " + cmd + " is not recognised as a valid command.");
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>