<%-- $Id: edit_eventtype.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateEventType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATEEVENTTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int plateTypeId = Values.getInt(request.getParameter("platetype_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateEventType eventType = null;
	PlateType plateType = null;
	
	ItemSubtype currentProtocolType = null;
	boolean readCurrentProtocolType = true;
	int maxOrdinal = 0;
	
	// Load recently used items
	List<ItemSubtype> recentProtocolTypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);

	if (itemId == 0)
	{
		title = "Create event type";
		cc.removeObject("item");
		plateType = PlateType.getById(dc, plateTypeId);
		if (cc.getPropertyFilter("protocolType.name") != null)
		{
			currentProtocolType = Base.getFirstMatching(dc, ItemSubtype.getQuery(Item.PROTOCOL), "name", cc.getPropertyFilter("protocolType.name"));
		}
		maxOrdinal = (int)plateType.getEventTypes().count(dc);
	}
	else
	{
		eventType = PlateEventType.getById(dc, itemId);
		plateType = eventType.getPlateType();
		cc.setObject("item", eventType);
		title = "Edit event type -- " + HTML.encodeTags(plateType.getName());
		try
		{
			currentProtocolType = eventType.getProtocolType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocolType = false;
		}
	}
	if (eventType != null && !eventType.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), eventType);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "EventType" tab
		function validateEventType()
		{
			var frm = document.forms['eventtype'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.ordinal.value) == '')
			{
				alert("You must enter an ordinal");
				frm.ordinal.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['eventtype'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function selectProtocolTypeOnClick()
		{
			var frm = document.forms['eventtype'];
			var url = '../../../admin/itemsubtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolTypeCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemType=<%=Item.PROTOCOL.getValue()%>';
			if (frm.protocoltype_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocoltype_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocolType', 1050, 700);
		}
		function setProtocolTypeCallback(id, name)
		{
			var frm = document.forms['eventtype'];
			var list = frm.protocoltype_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function init()
		{
			var frm = document.forms['eventtype'];
			<%
			if (eventType == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="eventtype" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="platetype_id" value="<%=plateTypeId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=eventType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Event type" validate="validateEventType()" helpid="plateeventtype.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(eventType == null ? Values.getString(cc.getPropertyValue("name"), "New event type") : eventType.getName())%>" 
					maxlength="<%=PlateEventType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Ordinal</th>
				<td><input <%=requiredClazz%> type="text" name="ordinal" style="width: 15em;"
					value="<%=eventType == null ? Values.getInt(cc.getPropertyValue("ordinal"), maxOrdinal+1) : eventType.getOrdinal()%>" 
					maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol type</th>
				<td>
					<base:select 
						id="protocoltype_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocolType%>"
						denied="<%=!readCurrentProtocolType%>"
						recent="<%=recentProtocolTypes%>"
						newitem="<%=eventType == null%>"
						onselect="selectProtocolTypeOnClick()"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" name="description" 
						><%=HTML.encodeTags(eventType == null ? cc.getPropertyValue("description") : eventType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'eventtype', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
