<%-- $Id: list_bioassays.jsp 6114 2012-09-12 07:41:37Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DERIVEDBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean createRawBioAssayPermission = sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("derived bioassay", "derived bioassays");
final DbControl dc = sc.newDbControl();
ItemResultIterator<DerivedBioAssay> bioAssays = null;
ItemResultList<AnnotationType> annotationTypes = null;
try
{
	final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);

	// Query for parent physical bioassays to the current bioassay
	final ItemQuery<PhysicalBioAssay> physicalBioAssayQuery = PhysicalBioAssay.getQuery();
	physicalBioAssayQuery.include(cc.getInclude());
	physicalBioAssayQuery.join(Hql.innerJoin("derivedBioAssays", "dba"));
	physicalBioAssayQuery.restrict(Restrictions.eq(Hql.alias("dba"), Expressions.parameter("bioAssay")));
	physicalBioAssayQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for parent bioassays to the current bioassay
	final ItemQuery<DerivedBioAssay> parentQuery = DerivedBioAssay.getQuery();
	parentQuery.include(cc.getInclude());
	parentQuery.join(Hql.innerJoin("children", "c"));
	parentQuery.restrict(Restrictions.eq(Hql.alias("c"), Expressions.parameter("bioAssay")));
	parentQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for child bioassays to the current bioassay
	final ItemQuery<DerivedBioAssay> childQuery = DerivedBioAssay.getQuery();
	childQuery.include(cc.getInclude());
	childQuery.join(Hql.innerJoin("parents", "p"));
	childQuery.restrict(Restrictions.eq(Hql.alias("p"), Expressions.parameter("bioAssay")));
	childQuery.order(Orders.asc(Hql.property("name"))); 

	// Query for raw bioassays to the current bioassay
	final ItemQuery<RawBioAssay> rawBioAssayQuery = RawBioAssay.getQuery();
	rawBioAssayQuery.include(cc.getInclude());
	rawBioAssayQuery.restrict(Restrictions.eq(Hql.property("parentBioAssay"), Expressions.parameter("bioAssay")));
	rawBioAssayQuery.order(Orders.asc(Hql.property("name"))); 
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	annotationTypes = annotationTypeQuery.list(dc);
	try
	{
		final ItemQuery<DerivedBioAssay> query = Base.getConfiguredQuery(dc, cc, true, DerivedBioAssay.getQuery(), mode);
		bioAssays = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title==null ? "Derived bioassays" : title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'bioassays';
		function newItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true);
		}
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', itemId);
		}
		function setOwner()
		{
			Table.setOwnerOfItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'SetOwnerOfItems');
		}
		function shareItem(itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id='+itemId, 'ShareItem', 600, 400);
		}
		function shareItems()
		{
			Table.shareItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'ShareItems');
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 750, 500);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function newChildBioAssay(parentId)
		{
			Main.viewOrEditItem('<%=ID%>', 'DERIVEDBIOASSAY', 0, true, '&parent_id='+parentId);
		}
		function newRawBioAssay(parentId)
		{
			Main.viewOrEditItem('<%=ID%>', 'RAWBIOASSAY', 0, true, '&bioassay_id='+parentId);
		}
		function newMergedChild()
		{
			var frm = document.forms[formId];
			Table.poolItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'NewMergedDerivedBioAssay');
		}
		</script>
	</base:head>
	
	<base:body>
		<h1><%=title==null ? "Derived bioassays" : title%></h1>
		<div class="content">
		<tbl:table 
			id="bioassays" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="itemSubtype"
				property="itemSubtype"
				sortproperty="itemSubtype.name"
				exportproperty="itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(subtypesQuery.list(dc), "-none-")%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="physicalBioAssays"
				property="&physicalBioAssays(name)"
				datatype="string"
				title="Physical bioassays"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="parents"
				property="&parents(name)"
				datatype="string"
				title="Parent bioassays"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="children"
				title="Child bioassays"
				property="&children(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="extract"
				property="extract.name"
				datatype="string"
				title="Extract"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="rawBioAssays"
				title="Raw bioassays"
				property="&rawBioAssays(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="plugin"
				property="job.pluginDefinition.name"
				datatype="string"
				title="Plugin"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="hardware"
				property="hardware.name"
				datatype="string"
				title="Hardware"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="software"
				property="software.name"
				datatype="string"
				title="Software"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<%
			for (AnnotationType at : annotationTypes)
			{
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				Enumeration<String, String> annotationEnum = null;
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						disabled="<%=!createPermission%>" 
						image="new.png" 
						onclick="newItem()" 
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new derived bioassay" : "You do not have permission to create derived bioassays"%>" 
					/>
					<tbl:button 
						disabled="<%=!createPermission%>" 
						image="new_pooled.png" 
						onclick="newMergedChild()" 
						title="Merge&hellip;" 
						tooltip="<%=createPermission ? "Create new merged bioassay" : "You do not have permission to create derived bioassay"%>" 
					/>
					<tbl:button 
						image="delete.png"
						onclick="deleteItems()" 
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						image="restore.png"
						onclick="restoreItems()" 
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
					/>
					<tbl:button 
						image="share.png"
						onclick="shareItems()" 
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						image="take_ownership.png"
						onclick="setOwner()" 
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						image="import.png" 
						onclick="runPlugin('ImportItems')" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						image="export.png" 
						onclick="runPlugin('ExportItems')" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						image="runplugin.png" 
						onclick="runPlugin('RunListPlugin')" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=bioAssays == null ? 0 : bioAssays.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								onclick="Forms.checkUncheck(document.forms[formId])" 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (bioAssays != null)
					{						
						while (bioAssays.hasNext())
						{
							DerivedBioAssay item = bioAssays.next();
							int itemId = item.getId();
							boolean usePermission = item.hasPermission(Permission.USE);
							String openSharePopup = "shareItem("+itemId+")";
							String deletePermanently = "deleteItemPermanently("+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="shared.png" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="itemSubtype"><base:propertyvalue 
										item="<%=item%>" 
										property="itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="children">
									<%
									childQuery.setParameter("bioAssay", itemId, Type.INT);
									try
									{
										String separator = "";
										for (DerivedBioAssay child : childQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, child, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(child.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>							
									<base:icon
										image="add.png" 
										onclick="<%="newChildBioAssay("+itemId+")"%>" 
										tooltip="Create new child bioassay" 
										visible="<%=mode.hasEditLink() && createPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="rawBioAssays">
									<%
									rawBioAssayQuery.setParameter("bioAssay", itemId, Type.INT);
									try
									{
										String separator = "";
										for (RawBioAssay rba : rawBioAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, rba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(rba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>							
									<base:icon
										image="add.png" 
										onclick="<%="newRawBioAssay("+itemId+")"%>" 
										tooltip="Create new raw bioassay" 
										visible="<%=mode.hasEditLink() && createRawBioAssayPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="physicalBioAssays">
									<%
									physicalBioAssayQuery.setParameter("bioAssay", itemId, Type.INT);
									try
									{
										String separator = "";
										for (PhysicalBioAssay pba : physicalBioAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, pba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(pba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>							
								</tbl:cell>
								<tbl:cell column="parents">
									<%
									if (!item.isRoot())
									{
										parentQuery.setParameter("bioAssay", itemId, Type.INT);
										try
										{
											String separator = "";
											for (DerivedBioAssay dba : parentQuery.list(dc))
											{
												out.write(separator);
												if (mode.hasPropertyLink())
												{
													out.write(Base.getLinkedName(ID, dba, false, mode.hasEditLink()));
												}
												else
												{
													out.write(HTML.encodeTags(dba.getName()));
												}
												separator = ", ";
											}
										}
										catch (Throwable t)
										{
											%>
											<div class="error"><%=t.getMessage()%></div>
											<%
										}
									}
									%>							
								</tbl:cell>
								<tbl:cell column="extract"
									><base:propertyvalue 
										item="<%=item%>" 
										property="extract"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="plugin"
									><base:propertyvalue 
										item="<%=item%>" 
										property="job.pluginDefinition"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=item%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="hardware"
									><base:propertyvalue 
										item="<%=item%>"
										property="hardware"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="software"
									><base:propertyvalue 
										item="<%=item%>"
										property="software"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<%
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								if (as != null)
								{
									for (AnnotationType at : annotationTypes)
									{
										if (as.hasAnnotation(at))
										{
											Annotation a = as.getAnnotation(at);
											String suffix = a.getUnitSymbol(null);
											if (suffix != null) suffix = "&nbsp;" + suffix;
											%>
											<tbl:cell 
												column="<%="at"+at.getId()%>"
												><tbl:cellvalue 
													list="<%=a.getValues(null)%>"
													suffix="<%=suffix%>"
											/></tbl:cell>
											<%
										}
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=bioAssays == null || bioAssays.getTotalCount() == 0 ? "No bioassays were found" : "No bioassays on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (bioAssays != null) bioAssays.close();
	if (dc != null) dc.close();
}
%>
