<%-- $Id: index.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http:// base.thep.lu.se/

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}

%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final float scale = Base.getScale(sc);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
	int bioAssayId = Values.getInt(request.getParameter("bioassay_id"));
	BioAssay ba = bioAssayId == 0 ? null : BioAssay.getById(dc, bioAssayId);
	BioAssaySet bas = ba == null ? BioAssaySet.getById(dc, bioAssaySetId) : ba.getBioAssaySet();
	RawDataType rdt = bas.getRawDataType();
	Experiment experiment = bas.getExperiment();
	int maxRawMappings = bas.getMaxRawMappingsForSpot();
	IntensityTransform transform = bas.getIntensityTransform();
	
	List<TableColumn> formulas = new LinkedList<TableColumn>();
	DynamicUtil.addSpotColumns(formulas, dc, rdt.getChannels(), transform);
	DynamicUtil.addFormulaColumns(formulas, dc, rdt, Formula.Type.COLUMN_EXPRESSION, 
			transform, "", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(formulas, dc, bas, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(formulas, dc, rdt, "", "", "[Raw] ");
	}
	
	StringBuilder formulaOptions = new StringBuilder();
	for (TableColumn tc : formulas)
	{
		if (tc.getJepExpression() != null && tc.getDatatype().isNumerical())
		{
			String jepExpression = tc.getJepExpression();
			addFormulaOption(formulaOptions, jepExpression, tc.getTitle(), tc.getDescription());
		}
	}
	
	StringBuilder filterOptions = new StringBuilder();
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.COLUMN_RESTRICTION, rdt, transform);
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	for (Formula formula : formulaQuery.list(dc))
	{
		String f = formula.getFormulas().get(0);
		if (maxRawMappings == 1 || !f.contains("raw("))
		{
			addFormulaOption(filterOptions, f, 
				formula.getName(), formula.getDescription());
		}
	}
	
	// Annnotations -- experimental factors and bioassay annotations
	final ItemQuery<AnnotationType> query = AnnotationType.getQuery(null);
	query.join(Hql.leftJoin("experiments", Item.EXPERIMENT.getAlias()));
	query.join(Hql.innerJoin("itemTypes", "itemType"));
	Restriction ef = Restrictions.eq(
		Hql.alias(Item.EXPERIMENT.getAlias()), 
		Hql.entity(experiment)
	);
	Restriction baa = Restrictions.eq(
		Hql.alias("itemType"),
		Expressions.integer(Item.BIOASSAY.getValue())
	);
	query.restrict(Restrictions.or(ef, baa));
	query.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	query.order(Orders.asc(Hql.property("name")));
	List<AnnotationType> experimentalFactors = query.list(dc);
	
	String title = HTML.encodeTags("Plot " + (ba == null ? bas.getName() : ba.getName()));
	
	final boolean hasCreateFilePermission = sc.hasPermission(Permission.CREATE, Item.FILE);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head styles="tabcontrol.css" scripts="tabcontrol.js">
	<script language="JavaScript">

	function validate()
	{
		var plotType = getPlotType();
		if (plotType == 'scatter')
		{
			return validateScatterPlot();
		}
		else if (plotType == 'histogram')
		{
			return validateHistogramPlot();
		}
		return false;
	}
	function validateScatterPlot()
	{
		var frm = document.forms['plot'];
		if (Main.trimString(frm.yFormulaScatter.value) == '')
		{
			alert("You must enter an expression for the Y axis");
			frm.yFormulaScatter.focus();
			return false;
		}
		else if (Main.trimString(frm.xFormulaScatter.value) == '')
		{
			alert("You must enter an expression for the X axis");
			frm.xFormulaScatter.focus();
			return false;
		}
		return true;
	}
	function validateHistogramPlot()
	{
		var frm = document.forms['plot'];
		var yAggregate = Forms.getCheckedRadio(frm.yAggregate).value;
		if (Main.trimString(frm.xFormulaHistogram.value) == '')
		{
			alert("You must enter an expression for the X axis");
			frm.xFormulaHistogram.focus();
			return false;
		}
		else if (yAggregate != 'count' && Main.trimString(frm.yFormulaHistogram.value) == '')
		{
			alert("You must enter an expression for the Y axis");
			frm.yFormulaHistogram.focus();
			return false;
		}
		return true;
	}

	function getPlotType()
	{
		var frm = document.forms['plot'];
		return Forms.getCheckedRadio(frm.plotType).value;
	}

	function plotTypeOnChange()
	{
		var isScatter = getPlotType() == 'scatter';
		Main.showHide('scatterSection', isScatter);
		Main.showHide('histogramSection', !isScatter);
	}

	function presetOnChange(list, formula, label)
	{
		var index = list.selectedIndex;
		formula.value = list[index].value;
		if (label && list[index].value != '') label.value = list[index].text;
		list.selectedIndex = 0;
	}
	
	function aggregateOnChange()
	{
		var frm = document.forms['plot'];
		var selected = Forms.getCheckedRadio(frm.yAggregate);
		var isCount = selected.value == 'count';
		frm.yFormulaHistogram.disabled = isCount;
		frm.yPresetsHistogram.disabled = isCount;
		frm.yLogHistogram.disabled = isCount;
		for (var i = 0; i < frm.hiloAggregate.length; i++)
		{
			frm.hiloAggregate[i].disabled = isCount;
		}
		if (isCount)
		{
			Main.removeClass(frm.yFormulaHistogram, 'required');
			frm.yLabelHistogram.value = 'Count';
		}
		else
		{
			Main.addClass(frm.yFormulaHistogram, 'required');
			var yPreset = frm.yPresetsHistogram[frm.yPresetsHistogram.selectedIndex];
			if (yPreset.value != '') frm.yLabelHistogram.value = yPresetHistogram.text;
		}
	}
	
	function annotationOnChange(list)
	{
		var frm = document.forms['plot'];
		var selected = list[list.selectedIndex];
		var value = selected.value && selected.value != '$' ? selected.text : '';
		value = value.replace('\[A\] ', '');
		frm.subTitle.value = value;
		
		if (selected.value.substring(0, 1) == '$')
		{
			frm.annotationExp.disabled = true;
		}
		else
		{
			if (selected.value)
			{
				frm.annotationExp.value = selected.value;
			}
			frm.annotationExp.disabled = false;
			frm.annotationExp.focus();
		}
	}
	
	function annotationExpressionOnChange()
	{
		var frm = document.forms['plot'];
		frm.annotationPresets.selectedIndex = annotationFrm.annotationPresets.length-1;
	}
	
	function generatePlotUrl(fullSize)
	{
		if (validate())
		{
			var frm = document.forms['plot'];
			var url = 'plot?ID=<%=ID%>&bioassayset_id=<%=bioAssaySetId%>&bioassay_id=<%=bioAssayId%>';
			url += '&title='+Main.encodeURI(frm.title.value);
			url += '&subTitle='+Main.encodeURI(frm.subTitle.value);
			if (fullSize)
			{
				url += '&width='+frm.width.value;
				url += '&height='+frm.height.value;
			}
			
			if (frm.filter.value != '')
			{
				url += '&filter='+Main.encodeURI(frm.filter.value);
			}
			
			var annotation = '';
			if (!frm.annotationExp.disabled)
			{
				if (frm.annotationExp.value)
				{
					annotation = '=' + frm.annotationExp.value;
				}
			}
			else
			{
				annotation = frm.annotationPresets[frm.annotationPresets.selectedIndex].value.substring(1);
			}
			if (annotation)
			{
				url += '&annotation='+Main.encodeURI(annotation);
			}

			var plotType = getPlotType();
			if (plotType == 'scatter')
			{
				url += '&type=scatter';
				url += '&x='+Main.encodeURI(frm.xFormulaScatter.value);
				url += '&xLabel='+Main.encodeURI(frm.xLabelScatter.value);
				url += '&xLog='+(frm.xLogScatter.checked ? 1 : 0);
				url += '&y='+Main.encodeURI(frm.yFormulaScatter.value);
				url += '&yLabel='+Main.encodeURI(frm.yLabelScatter.value);
				url += '&yLog='+(frm.yLogScatter.checked ? 1 : 0);
			}
			else
			{
				var yAggregate = Forms.getCheckedRadio(frm.yAggregate).value;
				url += '&type=histogram';
				url += '&x='+Main.encodeURI(frm.xFormulaHistogram.value);
				url += '&xLabel='+Main.encodeURI(frm.xLabelHistogram.value);
				url += '&xLog='+(frm.xLogHistogram.checked ? 1 : 0);
				url += '&binSize='+Main.encodeURI(frm.binSize.value);
				url += '&yAggregate='+yAggregate;
				url += '&yLabel='+Main.encodeURI(frm.yLabelHistogram.value);
				if (yAggregate != 'count')
				{
					url += '&y='+Main.encodeURI(frm.yFormulaHistogram.value);
					url += '&yLog='+(frm.yLogHistogram.checked ? 1 : 0);
					url += '&hiloAggregate='+Forms.getCheckedRadio(frm.hiloAggregate).value
				}
			}
			return url;
		}
	}
	
	function openExpressionBuilder(title, frmName, inputName, formulaType)
	{
		if (!document.forms[frmName][inputName].disabled)
		{
			var restrictions = formulaType == '<%=Formula.Type.COLUMN_RESTRICTION.name()%>';
			Main.expressionBuilder('<%=ID%>', title, frmName, inputName, formulaType, '<%=rdt.getId()%>', <%=rdt.getChannels()%>, restrictions, <%=bas.getId()%>);
		}
	}
	
	function previewPlot()
	{
		var url = generatePlotUrl(false);
		if (url)
		{
			url += '&width=540&height=360';

			var overlayImg = document.getElementById('overlay');
			overlayImg.src = getRoot()+'images/plot_generating.gif';
			
			var previewImg = document.getElementById('preview');
			previewImg.realImg = new Image();
			previewImg.realImg.onload = changePreviewImage;
			previewImg.realImg.src = url;
		}
	}
	
	function changePreviewImage()
	{
		var previewImg = document.getElementById('preview');
		previewImg.src = previewImg.realImg.src;
		previewImg.realImg = null;
		var overlayImg = document.getElementById('overlay');
		overlayImg.src = getRoot() + 'images/blankbutton.gif';
	}
	
	function viewPlot()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			var frm = document.forms['plot'];
			var width = parseInt(frm.width.value);
			var height = parseInt(frm.height.value);
			if (!width || width < 600) width = 600;
			if (!height || height < 400) height = 400;
			Main.openPopup('view.jsp?ID=<%=ID%>&title='+Main.encodeURI(frm.title.value), 'ViewPlot', width+150, height+100);
		}
	}
	
	function downloadPlot()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			Main.openPopup('download.jsp?ID=<%=ID%>', 'DownloadPlot', 300, 200);
		}
	}
	
	function savePlotAs()
	{
		var url = generatePlotUrl(true);
		if (url)
		{
			Main.openPopup('save_as.jsp?ID=<%=ID%>', 'SavePlotAs', 450, 300);
		}
	}
	
	function init()
	{
	}
	</script>
	</base:head>
	<base:body onload="init()">
	<h1><%=title%> <base:help helpid="plotter" /></h1>
	<form name="plot">
	<div class="content bottomborder">
		<div class="absolutefull rightborder" style="right: 550px;">
			<table class="fullform input100 smaller">
			<tbody>
				<tr>
					<th>Plot title</th>
					<td colspan="2"><input type="text" class="text" size="30" maxlength="255" name="title" 
						value="<%=HTML.encodeTags(ba == null ? bas.getName() : ba.getName())%>"></td>
				</tr>
				<tr>
					<th class="subprompt">Subtitle</th>
					<td colspan="2"><input type="text" class="text" maxlength="255" name="subTitle" 
						value=""></td>
				</tr>
				<tr>
					<th>Width</th>
					<td colspan="2"><input type="text" class="text" style="width: 10em;" maxlength="10" name="width" 
						value="900" onkeypress="return Numbers.integerOnly(event)"> (not used by preview)</td>
				</tr>
				<tr>
					<th>Height</th>
					<td colspan="2"><input type="text" class="text" style="width: 10em;" maxlength="10" name="height" 
						value="600" onkeypress="return Numbers.integerOnly(event)"></td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th>Plot type</th>
					<td colspan="2">
						<input type="radio" name="plotType" value="scatter" onchange="plotTypeOnChange()"
							id="plotTypeScatter" checked><label for="plotTypeScatter">Scatter</label>
						<input type="radio" name="plotType" value="histogram" onchange="plotTypeOnChange()"
							id="plotTypeHistogram"><label for="plotTypeHistogram">Histogram</label>
					</td>
				</tr>
			</tbody>
			<tbody id="scatterSection">
				<tr>
					<th>Y-axis</th>
					<td>
					<select name="yPresetsScatter" style="width: 25em;"
						onchange="presetOnChange(this, this.form.yFormulaScatter, this.form.yLabelScatter)" 
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="yFormulaScatter"></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('Y-axis expression', 'plot', 'yFormulaScatter', 'COLUMN_EXPRESSION')"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Y label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabelScatter" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLogScatter">Log scale</label></th>
					<td><input type="checkbox" name="yLogScatter" id="yLogScatter" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>X-axis</th>
					<td>
					<select name="xPresetsScatter" style="width: 25em;"
						onchange="presetOnChange(this, this.form.xFormulaScatter, this.form.xLabelScatter)" 
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="xFormulaScatter"></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('X-axis expression', 'plot', 'xFormulaScatter', 'COLUMN_EXPRESSION')"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">X label</th>
					<td><input type="text" class="text" maxlength="255" name="xLabelScatter" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="xLogScatter">Log scale</label></th>
					<td><input type="checkbox" name="xLogScatter" id="xLogScatter" value="1"></td>
					<td></td>
				</tr>
			</tbody>
			
			<tbody id="histogramSection" style="display: none;">
				<tr>
					<th>Y-axis</th>
					<td>
						<input type="radio" name="yAggregate" id="yAggregateCount" value="count" checked 
							onchange="aggregateOnChange()"><label for="yAggregateCount">Count</label>
						<input type="radio" name="yAggregate" id="yAggregateMean" value="mean"
							onchange="aggregateOnChange()"><label for="yAggregateMean">Mean</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Hi-lo</th>
					<td>
						<input type="radio" name="hiloAggregate" id="hiloAggregateNone" value="" checked
							><label for="hiloAggregateNone">None</label>
						<input type="radio" name="hiloAggregate" id="hiloAggregateMinMax" value="hilomaxmin"
							><label for="hiloAggregateMinMax">Min/Max</label>
						<input type="radio" name="hiloAggregate" id="hiloAggregateStdev" value="hilostdev"
							><label for="hiloAggregateStdev">Stdev</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Presets</th>
					<td>
					<select name="yPresetsHistogram" style="width: 25em;"
						onchange="presetOnChange(this, this.form.yFormulaHistogram, this.form.yLabelHistogram)" 
						disabled
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text" maxlength="255" name="yFormulaHistogram" disabled></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('Y-axis expression', 'plot', 'yFormulaHistogram', 'COLUMN_EXPRESSION')"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Y label</th>
					<td><input type="text" class="text" maxlength="255" name="yLabelHistogram" value="Count"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="yLogHistogram">Log scale</label></th>
					<td><input type="checkbox" name="yLogHistogram" id="yLogHistogram" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th>X-axis</th>
					<td>
					<select name="xPresetsHistogram"  style="width: 25em;"
						onchange="presetOnChange(this, this.form.xFormulaHistogram, this.form.xLabelHistogram)" 
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Expression</th>
					<td><input type="text" class="text required" maxlength="255" name="xFormulaHistogram"></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('X-axis expression', 'plot', 'xFormulaHistogram', 'COLUMN_EXPRESSION')"
						/>
					</td>
				</tr>
				<tr>
					<th class="subprompt">X label</th>
					<td><input type="text" class="text" maxlength="255" name="xLabelHistogram" value=""></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt"><label for="xLogHistogram">Log scale</label></th>
					<td><input type="checkbox" name="xLogHistogram" id="xLogHistogram" value="1"></td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">Bin size</th>
					<td><input type="text" class="text" name="binSize" value="1" style="width: 10em;"></td>
					<td></td>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th class="subprompt"></th>
					<td colspan="2"></td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Filter &amp; annotations</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Filter</th>
					<td colspan="2">
						<select name="filterPresets" style="width: 25em;"
							onchange="presetOnChange(this, this.form.filter, null)" 
							>
							<option value="">- select from list or enter formula below -
							<%=filterOptions.toString()%>
						</select>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td><input type="text" class="text" maxlength="255" name="filter" placeholder="leave empty to plot all values"></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('Filter expression', 'plot', 'filter', 'COLUMN_RESTRICTION')"
						/>
					</td>
				</tr>
				<tr>
					<th>Annotation</th>
					<td colspan="2">
						<select name="annotationPresets" onchange="annotationOnChange(this)" style="width: 25em;">
							<option value="$">- none -
							<%
							if (ba == null)
							{
								%>
								<option value="$bioassay">Bioassay
								<option value="$spots">Spots
								<option value="$arrayDesign.name">Array design
								<option value="$software.name">Software
								<option value="$protocol.name">Protocol
								<option value="$scan.scanner.name">Scanner
								<option value="$scan.protocol.name">Scanning protocol
								<option value="$scan.hybridization.protocol.name">Hybridization protocol
								<option value="$scan.hybridization.creationEvent.eventDate">Hybridization date
								<option value="" disabled>- annotations -
								<%
								for (AnnotationType at : experimentalFactors)
								{
									%>
									<option value="$<%=at.getId()%>">[A] <%=HTML.encodeTags(at.getName())%>
									<%
								}
							}
							%>
							<option value="" disabled>- expressions -
							<%=filterOptions.toString()%>
							<option value="">Other...
						</select>
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td><input type="text" class="text" maxlength="255" name="annotationExp"
						onchange="annotationExpressionOnChange()" disabled></td>
					<td>
						<base:icon
							image="expression_builder.png"
							tooltip="Use the Expression builder"
							onclick="openExpressionBuilder('Annotation filter', 'plot', 'annotationExp', 'COLUMN_RESTRICTION')"
						/>
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		
		<div class="absolutefull filled" style="width: 550px; left: auto;">
				
					<img src="../../../images/plot_empty.png" id="preview" 
						style="position: absolute; top: 5px; z-index: 1;">
					<img src="../../../images/plot_select.png" id="overlay" 
						style="position: absolute; top: 5px; z-index: 2;">
		</div>
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons">
		<base:button title="Preview" onclick="previewPlot()" 
			image="plotter_preview.png" tooltip="Generate a preview of the plot" 
		/>
		<base:button title="View&hellip;" onclick="viewPlot()" 
			image="plotter.png" tooltip="View a fullsized version of the plot (in a popup)" 
		/>
		<base:button title="Download&hellip;" onclick="downloadPlot()" 
			image="download.png"
			tooltip="Downlad a fullsized version of the plot to your computer" 
		/>
		<base:button title="Save as&hellip;" onclick="savePlotAs()" 
			image="saveas.png"
			disabled="<%=!hasCreateFilePermission%>"
			tooltip="<%=hasCreateFilePermission ? 
				"Save a fullsized version of the plot on the BASE server" :
				"You don't have permission to create files" %>" 
		/>
		<base:button onclick="window.close()" title="Close" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
